/*
  File autogenerated by gengetopt version 2.17
  generated with the following command:
  gengetopt --set-version=(paraslash 0.2.14, transient singularity) --set-package=ortp_recv --arg-struct-name=ortp_recv_args_info --file-name=ortp_recv.cmdline --func-name ortp_recv_cmdline_parser 

  The developers of gengetopt consider the fixed text that goes in all
  gengetopt output files to be in the public domain:
  we make no copyright claims on it.
*/

/* If we use autoconf.  */
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "getopt.h"

#include "ortp_recv.cmdline.h"

const char *ortp_recv_args_info_purpose = "";

const char *ortp_recv_args_info_usage = "Usage: ortp_recv [OPTIONS]...";

const char *ortp_recv_args_info_help[] = {
  "  -h, --help                    Print help and exit",
  "  -V, --version                 Print version and exit",
  "\nortp options:",
  "  -i, --host=STRING             ip or host to receive rtp packets from  \n                                  (default=`224.0.1.38')",
  "  -p, --port=portnumber         udp port.  (default=`1500')",
  "  -j, --jitter_compensation=milliseconds\n                                non-zero values enable ortp's adaptive jitter \n                                  compensation  (default=`400')",
    0
};

static
void clear_given (struct ortp_recv_args_info *args_info);
static
void clear_args (struct ortp_recv_args_info *args_info);

static int
ortp_recv_cmdline_parser_internal (int argc, char * const *argv, struct ortp_recv_args_info *args_info, int override, int initialize, int check_required, const char *additional_error);


static char *
gengetopt_strdup (const char *s);

static
void clear_given (struct ortp_recv_args_info *args_info)
{
  args_info->help_given = 0 ;
  args_info->version_given = 0 ;
  args_info->host_given = 0 ;
  args_info->port_given = 0 ;
  args_info->jitter_compensation_given = 0 ;
}

static
void clear_args (struct ortp_recv_args_info *args_info)
{
  args_info->host_arg = gengetopt_strdup ("224.0.1.38");
  args_info->host_orig = NULL;
  args_info->port_arg = 1500;
  args_info->port_orig = NULL;
  args_info->jitter_compensation_arg = 400;
  args_info->jitter_compensation_orig = NULL;
  
}

static
void init_args_info(struct ortp_recv_args_info *args_info)
{
  args_info->help_help = ortp_recv_args_info_help[0] ;
  args_info->version_help = ortp_recv_args_info_help[1] ;
  args_info->host_help = ortp_recv_args_info_help[3] ;
  args_info->port_help = ortp_recv_args_info_help[4] ;
  args_info->jitter_compensation_help = ortp_recv_args_info_help[5] ;
  
}

void
ortp_recv_cmdline_parser_print_version (void)
{
  printf ("%s %s\n", ORTP_RECV_CMDLINE_PARSER_PACKAGE, ORTP_RECV_CMDLINE_PARSER_VERSION);
}

void
ortp_recv_cmdline_parser_print_help (void)
{
  int i = 0;
  ortp_recv_cmdline_parser_print_version ();

  if (strlen(ortp_recv_args_info_purpose) > 0)
    printf("\n%s\n", ortp_recv_args_info_purpose);

  printf("\n%s\n\n", ortp_recv_args_info_usage);
  while (ortp_recv_args_info_help[i])
    printf("%s\n", ortp_recv_args_info_help[i++]);
}

void
ortp_recv_cmdline_parser_init (struct ortp_recv_args_info *args_info)
{
  clear_given (args_info);
  clear_args (args_info);
  init_args_info (args_info);
}

static void
ortp_recv_cmdline_parser_release (struct ortp_recv_args_info *args_info)
{
  
  if (args_info->host_arg)
    {
      free (args_info->host_arg); /* free previous argument */
      args_info->host_arg = 0;
    }
  if (args_info->host_orig)
    {
      free (args_info->host_orig); /* free previous argument */
      args_info->host_orig = 0;
    }
  if (args_info->port_orig)
    {
      free (args_info->port_orig); /* free previous argument */
      args_info->port_orig = 0;
    }
  if (args_info->jitter_compensation_orig)
    {
      free (args_info->jitter_compensation_orig); /* free previous argument */
      args_info->jitter_compensation_orig = 0;
    }
  
  clear_given (args_info);
}

int
ortp_recv_cmdline_parser_file_save(const char *filename, struct ortp_recv_args_info *args_info)
{
  FILE *outfile;
  int i = 0;

  outfile = fopen(filename, "w");

  if (!outfile)
    {
      fprintf (stderr, "%s: cannot open file for writing: %s\n", ORTP_RECV_CMDLINE_PARSER_PACKAGE, filename);
      return EXIT_FAILURE;
    }

  if (args_info->help_given) {
    fprintf(outfile, "%s\n", "help");
  }
  if (args_info->version_given) {
    fprintf(outfile, "%s\n", "version");
  }
  if (args_info->host_given) {
    if (args_info->host_orig) {
      fprintf(outfile, "%s=\"%s\"\n", "host", args_info->host_orig);
    } else {
      fprintf(outfile, "%s\n", "host");
    }
  }
  if (args_info->port_given) {
    if (args_info->port_orig) {
      fprintf(outfile, "%s=\"%s\"\n", "port", args_info->port_orig);
    } else {
      fprintf(outfile, "%s\n", "port");
    }
  }
  if (args_info->jitter_compensation_given) {
    if (args_info->jitter_compensation_orig) {
      fprintf(outfile, "%s=\"%s\"\n", "jitter_compensation", args_info->jitter_compensation_orig);
    } else {
      fprintf(outfile, "%s\n", "jitter_compensation");
    }
  }
  
  fclose (outfile);

  i = EXIT_SUCCESS;
  return i;
}

void
ortp_recv_cmdline_parser_free (struct ortp_recv_args_info *args_info)
{
  ortp_recv_cmdline_parser_release (args_info);
}


/* gengetopt_strdup() */
/* strdup.c replacement of strdup, which is not standard */
char *
gengetopt_strdup (const char *s)
{
  char *result = NULL;
  if (!s)
    return result;

  result = (char*)malloc(strlen(s) + 1);
  if (result == (char*)0)
    return (char*)0;
  strcpy(result, s);
  return result;
}

int
ortp_recv_cmdline_parser (int argc, char * const *argv, struct ortp_recv_args_info *args_info)
{
  return ortp_recv_cmdline_parser2 (argc, argv, args_info, 0, 1, 1);
}

int
ortp_recv_cmdline_parser2 (int argc, char * const *argv, struct ortp_recv_args_info *args_info, int override, int initialize, int check_required)
{
  int result;

  result = ortp_recv_cmdline_parser_internal (argc, argv, args_info, override, initialize, check_required, NULL);

  if (result == EXIT_FAILURE)
    {
      ortp_recv_cmdline_parser_free (args_info);
      exit (EXIT_FAILURE);
    }
  
  return result;
}

int
ortp_recv_cmdline_parser_required (struct ortp_recv_args_info *args_info, const char *prog_name)
{
  return EXIT_SUCCESS;
}

int
ortp_recv_cmdline_parser_internal (int argc, char * const *argv, struct ortp_recv_args_info *args_info, int override, int initialize, int check_required, const char *additional_error)
{
  int c;	/* Character of the parsed option.  */

  int error = 0;
  struct ortp_recv_args_info local_args_info;

  if (initialize)
    ortp_recv_cmdline_parser_init (args_info);

  ortp_recv_cmdline_parser_init (&local_args_info);

  optarg = 0;
  optind = 0;
  opterr = 1;
  optopt = '?';

  while (1)
    {
      int option_index = 0;
      char *stop_char;

      static struct option long_options[] = {
        { "help",	0, NULL, 'h' },
        { "version",	0, NULL, 'V' },
        { "host",	1, NULL, 'i' },
        { "port",	1, NULL, 'p' },
        { "jitter_compensation",	1, NULL, 'j' },
        { NULL,	0, NULL, 0 }
      };

      stop_char = 0;
      c = getopt_long (argc, argv, "hVi:p:j:", long_options, &option_index);

      if (c == -1) break;	/* Exit from `while (1)' loop.  */

      switch (c)
        {
        case 'h':	/* Print help and exit.  */
          ortp_recv_cmdline_parser_print_help ();
          ortp_recv_cmdline_parser_free (&local_args_info);
          exit (EXIT_SUCCESS);

        case 'V':	/* Print version and exit.  */
          ortp_recv_cmdline_parser_print_version ();
          ortp_recv_cmdline_parser_free (&local_args_info);
          exit (EXIT_SUCCESS);

        case 'i':	/* ip or host to receive rtp packets from.  */
          if (local_args_info.host_given)
            {
              fprintf (stderr, "%s: `--host' (`-i') option given more than once%s\n", argv[0], (additional_error ? additional_error : ""));
              goto failure;
            }
          if (args_info->host_given && ! override)
            continue;
          local_args_info.host_given = 1;
          args_info->host_given = 1;
          if (args_info->host_arg)
            free (args_info->host_arg); /* free previous string */
          args_info->host_arg = gengetopt_strdup (optarg);
          if (args_info->host_orig)
            free (args_info->host_orig); /* free previous string */
          args_info->host_orig = gengetopt_strdup (optarg);
          break;

        case 'p':	/* udp port..  */
          if (local_args_info.port_given)
            {
              fprintf (stderr, "%s: `--port' (`-p') option given more than once%s\n", argv[0], (additional_error ? additional_error : ""));
              goto failure;
            }
          if (args_info->port_given && ! override)
            continue;
          local_args_info.port_given = 1;
          args_info->port_given = 1;
          args_info->port_arg = strtol (optarg, &stop_char, 0);
          if (!(stop_char && *stop_char == '\0')) {
            fprintf(stderr, "%s: invalid numeric value: %s\n", argv[0], optarg);
            goto failure;
          }
          if (args_info->port_orig)
            free (args_info->port_orig); /* free previous string */
          args_info->port_orig = gengetopt_strdup (optarg);
          break;

        case 'j':	/* non-zero values enable ortp's adaptive jitter compensation.  */
          if (local_args_info.jitter_compensation_given)
            {
              fprintf (stderr, "%s: `--jitter_compensation' (`-j') option given more than once%s\n", argv[0], (additional_error ? additional_error : ""));
              goto failure;
            }
          if (args_info->jitter_compensation_given && ! override)
            continue;
          local_args_info.jitter_compensation_given = 1;
          args_info->jitter_compensation_given = 1;
          args_info->jitter_compensation_arg = strtol (optarg, &stop_char, 0);
          if (!(stop_char && *stop_char == '\0')) {
            fprintf(stderr, "%s: invalid numeric value: %s\n", argv[0], optarg);
            goto failure;
          }
          if (args_info->jitter_compensation_orig)
            free (args_info->jitter_compensation_orig); /* free previous string */
          args_info->jitter_compensation_orig = gengetopt_strdup (optarg);
          break;


        case 0:	/* Long option with no short option */
        case '?':	/* Invalid option.  */
          /* `getopt_long' already printed an error message.  */
          goto failure;

        default:	/* bug: option not considered.  */
          fprintf (stderr, "%s: option unknown: %c%s\n", ORTP_RECV_CMDLINE_PARSER_PACKAGE, c, (additional_error ? additional_error : ""));
          abort ();
        } /* switch */
    } /* while */




  ortp_recv_cmdline_parser_release (&local_args_info);

  if ( error )
    return (EXIT_FAILURE);

  return 0;

failure:
  
  ortp_recv_cmdline_parser_release (&local_args_info);
  return (EXIT_FAILURE);
}
